import collections

collaborators = 'Your collaborators here'


# Enter true or false for each part of problem 1.

answer_for_problem_1_part_a = False
# An edge of weight -2 becomes weight 4, while an edge of weight 1 becomes weight 1.   

answer_for_problem_1_part_b = False
# Paths may be different lengths

answer_for_problem_1_part_c = True
# The weight of a path from s to t is simply changed additively by d(s) - d(t) 


# Enter true or false for each part of problem 2.

answer_for_problem_2_part_a = False
# If a non-source is chosen initially, its parents will come later

answer_for_problem_2_part_b = False
# Consider the graph (1, 2), (3, 2).  

answer_for_problem_2_part_c = False
# This is equivalent to b

answer_for_problem_2_part_d = True
# See CLRS

answer_for_problem_2_part_e = True
# This is equivalent to d

# Enter your answer to problem 3 here. 
answer_for_problem_3 = '''
    
    The main idea for this problem it to perform a 
    modification of Bellman-Ford.
    First, before we perform this modification, we will transform the 
    weight function of the graph to be the following: if w : E -> R+ is
    the original weight function, our new weight function will be given 
    by f : E -> R such that f(e) = - log(w(e)). This way, the multiplication
    factor now becomes an additive factor in our graph, and we want to find
    a negative weighted cycle in this new graph, since this implies a cycle
    that gives us infinite money. But this cycle has to be reachable, since 
    we have to respect the constraint that we have to always have more than
    b dollars. This condition is translated to the new graph setting as:
    the sum of the weights of a path that I decide to take can never be 
    greater than log(1/b). Therefore, we apply the following modification 
    of Bellman-Ford to this graph:
    1) Initialize-single-source(G,s)
    2) for i = 1 to |V|-1:
        for each (u,v) in E
            if (v.d > u.d + f(u,v)) and u.d + f(u,v) < log(1/b)
            # need to check in the if statement if we can take the path
                v.d = u.d + f(u,v)
                v.pi = u
    3) for each (u,v) in E
        if v.d > u.d + f(u,v) and v.d < infinity
            return True (because we found a reachable negative weight cycle)
    4) return False

    
    This algorithm is correct because all the rechable vertices will 
    be the ones through paths that have all partial sums of weights 
    (from the beginning up to a vertex in the path)
    less than log(1/b) and we will only find a negative cycle if it is 
    reachable. The proof of this fact is similar to the one given in 
    CLRS for the original Bellman-Ford algorithm, the only modification
    in the analysis being that now we will discard the unreachable vertices.
'''

def find_distance(graph, s, t):
  if s == t: return 0
  slist, tlist = [s], [t]
  visited_s, visited_t = set(slist), set(tlist)
  i = 0
  
  def extend_level(oldlist, visited, other_visited, i):
    i+= 1
    newlist = []
    for old in oldlist:
      for new in graph[old]:
        if new not in visited:
          if new in other_visited: return (None, None, i)
          visited.add(new)
          newlist.append(new)
    return (newlist, visited, i)
  
  while slist and tlist:
    (slist, visited_s, i) = extend_level(slist, visited_s, visited_t, i)
    if not visited_s: return i
    (tlist, visited_t, i) = extend_level(tlist, visited_t, visited_s, i)
    if not visited_t: return i

  return None
